#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Realizzare la funzione f(s) seguente. La funzione accetta come
   parametro una stringa s, che puo' essere vuota e non deve essere
   modificata. 

   La funzione deve restituire 1 se e solo se la stringa s e' una
   password "valida" secondo una serie di regole. Specificamente la
   funzione deve restituire 1 se valgono TUTTE le condizioni seguenti:

   1. La stringa s ha lunghezza maggiore o uguale a 9

   2. La stringa s non contiene piu' di 3 caratteri consecutivi uguali
   
   3. La stringa s contiene almeno 3 lettere maiuscole
      ('A', ... 'Z')

   4. La stringa s contiene almeno 2 caratteri numerici
      ('0', ... '9')

   Nel caso in cui qualcunq delle condizioni precedenti non sia
   soddisfatta, la funzione restituisce 0.

   E' consentito usare qualunque funzione presente nell'header file
   <string.h> (comunque l'unica che potrebbe essere utile e'
   strlen()).
*/
int f(char *s)
{
    return -1;
}

void test(char *s, int expect)
{
    const int r = f(s);
    if (r == expect) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: s=\"%s\", risultato atteso=%d, risultato ottenuto=%d\n", s, expect, r);
    }
}

int main( void )
{
    test("", 0);
    test("ciao", 0);
    test("123456789101", 0);
    test("PROVA11322", 1);
    test("eSEmPiio112", 1);
    test("non_va_bene", 0);
    test("tttroppe_UGUALIi1", 0);
    return 0;
}
